// une fonction quelconque de laplacien non constant et non constante au bord
//#  define isDirichlet(x) ((x)==1 || (x)==5 || (x)==2 || (x)==3 || (x)==4 || (x)==6 )
//#  define isNeumann(x)   (false )
//#  define isRobin(x)     (false )
//#  define isDirichlet(x) ((x)==1 || (x)==3 || (x)==4 || (x)==5)
//#  define isNeumann(x)   ((x)==2 || (x)==6 )
//#  define isRobin(x)     (false )
#  define isDirichlet(x) ((x)==1 || (x)==5)
#  define isNeumann(x)   ((x)==2 || (x)==3)
#  define isRobin(x)     ((x)==4 || (x)==6)
#define MESHFILE "hexaedre.msh"

R TetaExact ( R3 & P ) { return 10*(2*P.x*P.y*P.z-10*P.y*P.x*P.x+6*P.z*P.z*P.x); }
R3 GradF ( R3 & P ) { return 10*R3(
			2*P.y*P.z-20*P.y*P.x  +6*P.z*P.z,
			2*P.x*P.z-10*P.x*P.x  ,
			2*P.x*P.y             +12*P.x*P.z ); }
R fOmega( R3 & P) { return  10*(20*P.y-12*P.x); }
#define UDirichlet TetaExact
R UNeumann(  R3 & P, Label l) {
	return (GradF(P), normale(l));
}

#define TetaRobin ( 300. )
R TetaExtRobin( R3 & P ) { return TetaRobin; } // temperature exterieur, frontiere de Robin
R GRobin( R3 & P , Label l) { // coefficient d'echange pour la frontiere de Robin
	// la, on triche :)
	return UNeumann( P,l ) /( TetaExtRobin( P )-TetaExact( P ) );
}

