#ifndef QUADRATUREFORMULA
#define QUADRATUREFORMULA

// those include because Matrice.. isn't self-contained...
#include <cassert>
#include "throwassert.hpp"
#include "MatriceCreuse_tpl.hpp"   //pour la matrice globale EF profil



namespace Fem3D  //=========================================================================
{

//typedef double R;

// my own 3d Quadrature formula
typedef struct { R x,y; R poids; } Quadrature2DPoint;
typedef struct { R x,y,z; R poids; } Quadrature3DPoint;

/// Those provided by Quadrature.cpp

extern Quadrature2DPoint Formula2D_3PointsAxisymetrie[];
extern Quadrature2DPoint Formula2D_7Points[];

extern Quadrature3DPoint Formula3D_4Points[];
extern Quadrature3DPoint Formula3D_15Points[];


} // namespace

#endif  // QUADRATUREFORMULA
