
// l'exemple de comparaison avec les autres
/*
 * Labels:
 */
//  hexaedre.msh :
//        2   {est le NUMERO ou LABEL dans SURFACE    de } HAUT
//        6   {est le NUMERO ou LABEL dans SURFACE    de } DROITE
//        4   {est le NUMERO ou LABEL dans SURFACE    de } DEVANT
//        5   {est le NUMERO ou LABEL dans SURFACE    de } GAUCHE
//        3   {est le NUMERO ou LABEL dans SURFACE    de } DERRIERE
//        1   {est le NUMERO ou LABEL dans SURFACE    de } BASE
#if 0
#  define isDirichlet(x) ((x)>=1 && (x)<=6)
#  define isNeumann(x)   (false)
#  define isRobin(x)   (false)
#  else
#  define isDirichlet(x) ((x)>=2 && (x)<=6)
#  define isNeumann(x)   ((x)==1)
#  define isRobin(x)     (false )
//#  define isNeumann(x)   (false )
//#define isDirichlet(x) ((x)>0 && (x)<7) // de 1 a 6 inclus
#endif
#define MESHFILE "hexaedre.msh"


// on prends l'exemple de teta(x,y) = x*x + y*y + z*z

#define UDirichlet TetaExact
R TetaExact ( R3 & P ) { return P.x*P.x + P.y*P.y + P.z*P.z; }
R fOmega( R3 & P) { return  -6.;} // laplacien constant = 6

R UNeumann(  R3 & P, Label l) {
	// le gradient vaut 2*P, et donc la derivee normale (grad,n)
	return 2*(P, normale( l ));
}

#define TetaRobin ( 20. )
#define G  ( 1. )
R TetaExtRobin( R3 & P ) { return TetaRobin; } // temperature exterieur, frontiere de Robin
R GRobin( R3 & P , Label l) { // coefficient d'echange pour la frontiere de Robin
	// la, on triche :)
	return UNeumann( P,l ) /( TetaExtRobin( P )-TetaExact( P ) );
}
